#include <chrono>
#include <iostream>
#include <typeinfo>

int quad(int a){ return a*a; }

template <typename T1, typename T2>
auto add(T1 fir, T2 sec) -> decltype(fir + sec){
  return fir + sec;
}

int main(){

  std::cout << std::endl;

  auto begin= std::chrono::system_clock::now();

  int(*funcPtrCpp)(int);
  funcPtrCpp= &quad;
  auto funcAuto= quad;

  std::cout << "funcPtrCpp(5): " << funcPtrCpp(5) << std::endl;
  std::cout << "funcAuto(5): " << funcAuto(5) << std::endl;

  std::cout << std::endl;

  int (*addCpp)(int,int)= [](int a, int b){ return a+b;};
  auto addAuto= [](int a, int b){ return a+b;};

  std::cout << "addCpp(2000,11): " << addCpp(2000,11) << std::endl;
  std::cout << "addAuto(2000,11): " << addAuto(2000,11) << std::endl;

  std::cout << std::endl;

  auto a= add(2000,11);
  auto b= add(2000L,11);
  auto c= add(3,0.1415);

  std::cout << "a: " << a <<  " of type " << typeid(a).name() << std::endl;
  std::cout << "b: " << b <<  " of type " << typeid(b).name() << std::endl;
  std::cout << "c: " << c <<  " of type " << typeid(c).name() << std::endl;

  std::cout << std::endl;

  std::chrono::system_clock::time_point end= std::chrono::system_clock::now();
  auto elapsed = std::chrono::duration_cast<std::chrono::microseconds>(end - begin);
  std::cout << elapsed.count() << " microseconds " << '\n';

  std::cout << std::endl;

}

